diff --git a/_ide_helper.php b/_ide_helper.php
index b307038..8aa4dcb 100644
--- a/_ide_helper.php
+++ b/_ide_helper.php
@@ -7408,7 +6678,7 @@ namespace {
          * Here is the process to determine the format:
          * 
          *  * format defined by the user (with setRequestFormat())
-         *  * _format request attribute
+         *  * _format request parameter
          *  * $default
          *
          * @param string $default The default format
@@ -7423,7 +6693,7 @@ namespace {
         /**
          * Sets the request format.
          *
-         * @param string $format The request format
+         * @param string $format The request format.
          * @static 
          */
         public static function setRequestFormat($format){
@@ -7489,7 +6759,7 @@ namespace {
         /**
          * Checks if the request method is of specified type.
          *
-         * @param string $method Uppercase request method (GET, POST etc)
+         * @param string $method Uppercase request method (GET, POST etc).
          * @return bool 
          * @static 
          */
@@ -7513,7 +6783,7 @@ namespace {
          * Returns the request body content.
          *
          * @param bool $asResource If true, a resource will be returned
-         * @return string|resource The request body content or a resource to read the body stream
+         * @return string|resource The request body content or a resource to read the body stream.
          * @throws \LogicException
          * @static 
          */
@@ -7616,20 +6886,6 @@ namespace {
         }
         
         /**
-         * Indicates whether this request originated from a trusted proxy.
-         * 
-         * This can be useful to determine whether or not to trust the
-         * contents of a proxy-specific header.
-         *
-         * @return bool true if the request came from a trusted proxy, false otherwise
-         * @static 
-         */
-        public static function isFromTrustedProxy(){
-            //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::isFromTrustedProxy();
-        }
-        
-        /**
          * Register a custom macro.
          *
          * @param string $name
@@ -7853,50 +7109,27 @@ namespace {
         }
         
         /**
-         * Set the fallback locale being used.
-         *
-         * @param string $fallback
-         * @return void 
-         * @static 
-         */
-        public static function setFallback($fallback){
-            \Illuminate\Translation\Translator::setFallback($fallback);
-        }
-        
-        /**
-         * Set the parsed value of a key.
-         *
-         * @param string $key
-         * @param array $parsed
-         * @return void 
-         * @static 
-         */
-        public static function setParsedKey($key, $parsed){
-            //Method inherited from \Illuminate\Support\NamespacedItemResolver            
-            \Illuminate\Translation\Translator::setParsedKey($key, $parsed);
-        }
-        
-        /**
-         * Register a custom macro.
+         * Set the fallback locale being used.
          *
-         * @param string $name
-         * @param callable $macro
+         * @param string $fallback
          * @return void 
          * @static 
          */
-        public static function macro($name, $macro){
-            \Illuminate\Translation\Translator::macro($name, $macro);
+        public static function setFallback($fallback){
+            \Illuminate\Translation\Translator::setFallback($fallback);
         }
         
         /**
-         * Checks if macro is registered.
+         * Set the parsed value of a key.
          *
-         * @param string $name
-         * @return bool 
+         * @param string $key
+         * @param array $parsed
+         * @return void 
          * @static 
          */
-        public static function hasMacro($name){
-            return \Illuminate\Translation\Translator::hasMacro($name);
+        public static function setParsedKey($key, $parsed){
+            //Method inherited from \Illuminate\Support\NamespacedItemResolver            
+            \Illuminate\Translation\Translator::setParsedKey($key, $parsed);
         }
         
     }
@@ -8121,232 +7354,6 @@ namespace {
     }
 
 
-    class Mail extends \Illuminate\Support\Facades\Mail{
-        
-        /**
-         * Set the global from address and name.
-         *
-         * @param string $address
-         * @param string|null $name
-         * @return void 
-         * @static 
-         */
-        public static function alwaysFrom($address, $name = null){
-            \Illuminate\Mail\Mailer::alwaysFrom($address, $name);
-        }
-        
-        /**
-         * Set the global to address and name.
-         *
-         * @param string $address
-         * @param string|null $name
-         * @return void 
-         * @static 
-         */
-        public static function alwaysTo($address, $name = null){
-            \Illuminate\Mail\Mailer::alwaysTo($address, $name);
-        }
-        
-        /**
-         * Begin the process of mailing a mailable class instance.
-         *
-         * @param mixed $users
-         * @return \Illuminate\Mail\MailableMailer 
-         * @static 
-         */
-        public static function to($users){
-            return \Illuminate\Mail\Mailer::to($users);
-        }
-        
-        /**
-         * Begin the process of mailing a mailable class instance.
-         *
-         * @param mixed $users
-         * @return \Illuminate\Mail\MailableMailer 
-         * @static 
-         */
-        public static function bcc($users){
-            return \Illuminate\Mail\Mailer::bcc($users);
-        }
-        
-        /**
-         * Send a new message when only a raw text part.
-         *
-         * @param string $text
-         * @param mixed $callback
-         * @return void 
-         * @static 
-         */
-        public static function raw($text, $callback){
-            \Illuminate\Mail\Mailer::raw($text, $callback);
-        }
-        
-        /**
-         * Send a new message when only a plain part.
-         *
-         * @param string $view
-         * @param array $data
-         * @param mixed $callback
-         * @return void 
-         * @static 
-         */
-        public static function plain($view, $data, $callback){
-            \Illuminate\Mail\Mailer::plain($view, $data, $callback);
-        }
-        
-        /**
-         * Send a new message using a view.
-         *
-         * @param string|array $view
-         * @param array $data
-         * @param \Closure|string $callback
-         * @return void 
-         * @static 
-         */
-        public static function send($view, $data = array(), $callback = null){
-            \Illuminate\Mail\Mailer::send($view, $data, $callback);
-        }
-        
-        /**
-         * Queue a new e-mail message for sending.
-         *
-         * @param string|array $view
-         * @param array $data
-         * @param \Closure|string $callback
-         * @param string|null $queue
-         * @return mixed 
-         * @static 
-         */
-        public static function queue($view, $data = array(), $callback = null, $queue = null){
-            return \Illuminate\Mail\Mailer::queue($view, $data, $callback, $queue);
-        }
-        
-        /**
-         * Queue a new e-mail message for sending on the given queue.
-         *
-         * @param string $queue
-         * @param string|array $view
-         * @param array $data
-         * @param \Closure|string $callback
-         * @return mixed 
-         * @static 
-         */
-        public static function onQueue($queue, $view, $data, $callback){
-            return \Illuminate\Mail\Mailer::onQueue($queue, $view, $data, $callback);
-        }
-        
-        /**
-         * Queue a new e-mail message for sending on the given queue.
-         * 
-         * This method didn't match rest of framework's "onQueue" phrasing. Added "onQueue".
-         *
-         * @param string $queue
-         * @param string|array $view
-         * @param array $data
-         * @param \Closure|string $callback
-         * @return mixed 
-         * @static 
-         */
-        public static function queueOn($queue, $view, $data, $callback){
-            return \Illuminate\Mail\Mailer::queueOn($queue, $view, $data, $callback);
-        }
-        
-        /**
-         * Queue a new e-mail message for sending after (n) seconds.
-         *
-         * @param int $delay
-         * @param string|array $view
-         * @param array $data
-         * @param \Closure|string $callback
-         * @param string|null $queue
-         * @return mixed 
-         * @static 
-         */
-        public static function later($delay, $view, $data = array(), $callback = null, $queue = null){
-            return \Illuminate\Mail\Mailer::later($delay, $view, $data, $callback, $queue);
-        }
-        
-        /**
-         * Queue a new e-mail message for sending after (n) seconds on the given queue.
-         *
-         * @param string $queue
-         * @param int $delay
-         * @param string|array $view
-         * @param array $data
-         * @param \Closure|string $callback
-         * @return mixed 
-         * @static 
-         */
-        public static function laterOn($queue, $delay, $view, $data, $callback){
-            return \Illuminate\Mail\Mailer::laterOn($queue, $delay, $view, $data, $callback);
-        }
-        
-        /**
-         * Get the view factory instance.
-         *
-         * @return \Illuminate\Contracts\View\Factory 
-         * @static 
-         */
-        public static function getViewFactory(){
-            return \Illuminate\Mail\Mailer::getViewFactory();
-        }
-        
-        /**
-         * Get the Swift Mailer instance.
-         *
-         * @return \Swift_Mailer 
-         * @static 
-         */
-        public static function getSwiftMailer(){
-            return \Illuminate\Mail\Mailer::getSwiftMailer();
-        }
-        
-        /**
-         * Get the array of failed recipients.
-         *
-         * @return array 
-         * @static 
-         */
-        public static function failures(){
-            return \Illuminate\Mail\Mailer::failures();
-        }
-        
-        /**
-         * Set the Swift Mailer instance.
-         *
-         * @param \Swift_Mailer $swift
-         * @return void 
-         * @static 
-         */
-        public static function setSwiftMailer($swift){
-            \Illuminate\Mail\Mailer::setSwiftMailer($swift);
-        }
-        
-        /**
-         * Set the queue manager instance.
-         *
-         * @param \Illuminate\Contracts\Queue\Queue $queue
-         * @return $this 
-         * @static 
-         */
-        public static function setQueue($queue){
-            return \Illuminate\Mail\Mailer::setQueue($queue);
-        }
-        
-        /**
-         * Set the IoC container instance.
-         *
-         * @param \Illuminate\Contracts\Container\Container $container
-         * @return void 
-         * @static 
-         */
-        public static function setContainer($container){
-            \Illuminate\Mail\Mailer::setContainer($container);
-        }
-        
-    }
-
-
     class Password extends \Illuminate\Support\Facades\Password{
         
         /**
@@ -8818,6 +7825,7 @@ namespace {
         /**
          * Determine if the current request URI matches a pattern.
          *
+         * @param mixed  string
          * @return bool 
          * @static 
          */
@@ -8828,6 +7836,7 @@ namespace {
         /**
          * Determine if the current request URL and query string matches a pattern.
          *
+         * @param mixed  string
          * @return bool 
          * @static 
          */
@@ -8930,7 +7939,7 @@ namespace {
         }
         
         /**
-         * Get a subset containing the provided keys with values from the input data.
+         * Get a subset of the items from the input data.
          *
          * @param array|mixed $keys
          * @return array 
@@ -8952,17 +7961,6 @@ namespace {
         }
         
         /**
-         * Intersect an array of items with the input data.
-         *
-         * @param array|mixed $keys
-         * @return array 
-         * @static 
-         */
-        public static function intersect($keys){
-            return \Illuminate\Http\Request::intersect($keys);
-        }
-        
-        /**
          * Retrieve a query string item from the request.
          *
          * @param string $key
@@ -9012,7 +8010,7 @@ namespace {
          *
          * @param string $key
          * @param mixed $default
-         * @return \Illuminate\Http\UploadedFile|array|null 
+         * @return \Symfony\Component\HttpFoundation\File\UploadedFile|array|null 
          * @static 
          */
         public static function file($key = null, $default = null){
@@ -9031,17 +8029,6 @@ namespace {
         }
         
         /**
-         * Determine if a header is set on the request.
-         *
-         * @param string $key
-         * @return bool 
-         * @static 
-         */
-        public static function hasHeader($key){
-            return \Illuminate\Http\Request::hasHeader($key);
-        }
-        
-        /**
          * Retrieve a header from the request.
          *
          * @param string $key
@@ -9178,16 +8165,6 @@ namespace {
         }
         
         /**
-         * Determine if the current request probably expects a JSON response.
-         *
-         * @return bool 
-         * @static 
-         */
-        public static function expectsJson(){
-            return \Illuminate\Http\Request::expectsJson();
-        }
-        
-        /**
          * Determine if the current request is asking for JSON in return.
          *
          * @return bool 
@@ -9280,7 +8257,7 @@ namespace {
          * @param array $cookies The COOKIE parameters
          * @param array $files The FILES parameters
          * @param array $server The SERVER parameters
-         * @return \Request The duplicated request
+         * @return \Symfony\Component\HttpFoundation\Request The duplicated request
          * @static 
          */
         public static function duplicate($query = null, $request = null, $attributes = null, $cookies = null, $files = null, $server = null){
@@ -9450,7 +8427,7 @@ namespace {
         /**
          * Creates a new request with values from PHP's super globals.
          *
-         * @return \Request A new request
+         * @return \Symfony\Component\HttpFoundation\Request A new request
          * @static 
          */
         public static function createFromGlobals(){
@@ -9471,7 +8448,7 @@ namespace {
          * @param array $files The request files ($_FILES)
          * @param array $server The server parameters ($_SERVER)
          * @param string $content The raw body data
-         * @return \Request A Request instance
+         * @return \Symfony\Component\HttpFoundation\Request A Request instance
          * @static 
          */
         public static function create($uri, $method = 'GET', $parameters = array(), $cookies = array(), $files = array(), $server = array(), $content = null){
@@ -9523,7 +8500,7 @@ namespace {
         /**
          * Gets the list of trusted proxies.
          *
-         * @return array An array of trusted proxies
+         * @return array An array of trusted proxies.
          * @static 
          */
         public static function getTrustedProxies(){
@@ -9547,7 +8524,7 @@ namespace {
         /**
          * Gets the list of trusted host patterns.
          *
-         * @return array An array of trusted host patterns
+         * @return array An array of trusted host patterns.
          * @static 
          */
         public static function getTrustedHosts(){
@@ -9644,7 +8621,7 @@ namespace {
          * Order of precedence: PATH (routing placeholders or custom attributes), GET, BODY
          *
          * @param string $key the key
-         * @param mixed $default the default value if the parameter key does not exist
+         * @param mixed $default the default value
          * @return mixed 
          * @static 
          */
@@ -10067,18 +9044,6 @@ namespace {
         }
         
         /**
-         * Gets the mime types associated with the format.
-         *
-         * @param string $format The format
-         * @return array The associated mime types
-         * @static 
-         */
-        public static function getMimeTypes($format){
-            //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::getMimeTypes($format);
-        }
-        
-        /**
          * Gets the format associated with the mime type.
          *
          * @param string $mimeType The associated mime type
@@ -10108,7 +9073,7 @@ namespace {
          * Here is the process to determine the format:
          * 
          *  * format defined by the user (with setRequestFormat())
-         *  * _format request attribute
+         *  * _format request parameter
          *  * $default
          *
          * @param string $default The default format
@@ -10123,7 +9088,7 @@ namespace {
         /**
          * Sets the request format.
          *
-         * @param string $format The request format
+         * @param string $format The request format.
          * @static 
          */
         public static function setRequestFormat($format){
@@ -10189,7 +9154,7 @@ namespace {
         /**
          * Checks if the request method is of specified type.
          *
-         * @param string $method Uppercase request method (GET, POST etc)
+         * @param string $method Uppercase request method (GET, POST etc).
          * @return bool 
          * @static 
          */
@@ -10213,7 +9178,7 @@ namespace {
          * Returns the request body content.
          *
          * @param bool $asResource If true, a resource will be returned
-         * @return string|resource The request body content or a resource to read the body stream
+         * @return string|resource The request body content or a resource to read the body stream.
          * @throws \LogicException
          * @static 
          */
@@ -10316,20 +9281,6 @@ namespace {
         }
         
         /**
-         * Indicates whether this request originated from a trusted proxy.
-         * 
-         * This can be useful to determine whether or not to trust the
-         * contents of a proxy-specific header.
-         *
-         * @return bool true if the request came from a trusted proxy, false otherwise
-         * @static 
-         */
-        public static function isFromTrustedProxy(){
-            //Method inherited from \Symfony\Component\HttpFoundation\Request            
-            return \Illuminate\Http\Request::isFromTrustedProxy();
-        }
-        
-        /**
          * Register a custom macro.
          *
          * @param string $name
@@ -10387,7 +9338,7 @@ namespace {
         /**
          * Return a new JSON response from the application.
          *
-         * @param mixed $data
+         * @param string|array $data
          * @param int $status
          * @param array $headers
          * @param int $options
@@ -10402,7 +9353,7 @@ namespace {
          * Return a new JSONP response from the application.
          *
          * @param string $callback
-         * @param mixed $data
+         * @param string|array $data
          * @param int $status
          * @param array $headers
          * @param int $options
@@ -10648,14 +9599,39 @@ namespace {
         }
         
         /**
+         * Register an array of controllers with wildcard routing.
+         *
+         * @param array $controllers
+         * @return void 
+         * @deprecated since version 5.2.
+         * @static 
+         */
+        public static function controllers($controllers){
+            \Illuminate\Routing\Router::controllers($controllers);
+        }
+        
+        /**
+         * Route a controller to a URI with wildcard routing.
+         *
+         * @param string $uri
+         * @param string $controller
+         * @param array $names
+         * @return void 
+         * @deprecated since version 5.2.
+         * @static 
+         */
+        public static function controller($uri, $controller, $names = array()){
+            \Illuminate\Routing\Router::controller($uri, $controller, $names);
+        }
+        
+        /**
          * Set the unmapped global resource parameters to singular.
          *
-         * @param bool $singular
          * @return void 
          * @static 
          */
-        public static function singularResourceParameters($singular = true){
-            \Illuminate\Routing\Router::singularResourceParameters($singular);
+        public static function singularResourceParameters(){
+            \Illuminate\Routing\Router::singularResourceParameters();
         }
         
         /**
@@ -10777,8 +9753,8 @@ namespace {
          * @return array 
          * @static 
          */
-        public static function gatherRouteMiddleware($route){
-            return \Illuminate\Routing\Router::gatherRouteMiddleware($route);
+        public static function gatherRouteMiddlewares($route){
+            return \Illuminate\Routing\Router::gatherRouteMiddlewares($route);
         }
         
         /**
@@ -10793,28 +9769,6 @@ namespace {
         }
         
         /**
-         * Substitute the route bindings onto the route.
-         *
-         * @param \Illuminate\Routing\Route $route
-         * @return \Illuminate\Routing\Route 
-         * @static 
-         */
-        public static function substituteBindings($route){
-            return \Illuminate\Routing\Router::substituteBindings($route);
-        }
-        
-        /**
-         * Substitute the implicit Eloquent model bindings for the route.
-         *
-         * @param \Illuminate\Routing\Route $route
-         * @return void 
-         * @static 
-         */
-        public static function substituteImplicitBindings($route){
-            \Illuminate\Routing\Router::substituteImplicitBindings($route);
-        }
-        
-        /**
          * Register a route matched event listener.
          *
          * @param string|callable $callback
@@ -10894,7 +9848,7 @@ namespace {
          * @param string $class
          * @param \Closure|null $callback
          * @return void 
-         * @throws \Illuminate\Database\Eloquent\ModelNotFoundException
+         * @throws \Symfony\Component\HttpKernel\Exception\NotFoundHttpException
          * @static 
          */
         public static function model($key, $class, $callback = null){
@@ -11035,6 +9989,7 @@ namespace {
         /**
          * Alias for the "currentRouteNamed" method.
          *
+         * @param mixed  string
          * @return bool 
          * @static 
          */
@@ -11066,6 +10021,7 @@ namespace {
         /**
          * Alias for the "currentRouteUses" method.
          *
+         * @param mixed  string
          * @return bool 
          * @static 
          */
@@ -11278,28 +10234,6 @@ namespace {
         }
         
         /**
-         * Enable foreign key constraints.
-         *
-         * @return bool 
-         * @static 
-         */
-        public static function enableForeignKeyConstraints(){
-            //Method inherited from \Illuminate\Database\Schema\Builder            
-            return \Illuminate\Database\Schema\MySqlBuilder::enableForeignKeyConstraints();
-        }
-        
-        /**
-         * Disable foreign key constraints.
-         *
-         * @return bool 
-         * @static 
-         */
-        public static function disableForeignKeyConstraints(){
-            //Method inherited from \Illuminate\Database\Schema\Builder            
-            return \Illuminate\Database\Schema\MySqlBuilder::disableForeignKeyConstraints();
-        }
-        
-        /**
          * Get the database connection instance.
          *
          * @return \Illuminate\Database\Connection 
@@ -11409,7 +10343,7 @@ namespace {
         /**
          * Starts the session storage.
          *
-         * @return bool True if session started
+         * @return bool True if session started.
          * @throws \RuntimeException If session fails to start.
          * @static 
          */
@@ -11420,7 +10354,7 @@ namespace {
         /**
          * Returns the session ID.
          *
-         * @return string The session ID
+         * @return string The session ID.
          * @static 
          */
         public static function getId(){
@@ -11451,7 +10385,7 @@ namespace {
         /**
          * Returns the session name.
          *
-         * @return mixed The session name
+         * @return mixed The session name.
          * @static 
          */
         public static function getName(){
@@ -11478,7 +10412,7 @@ namespace {
          *                      will leave the system settings unchanged, 0 sets the cookie
          *                      to expire with browser session. Time is in seconds, and is
          *                      not a Unix timestamp.
-         * @return bool True if session invalidated, false if error
+         * @return bool True if session invalidated, false if error.
          * @static 
          */
         public static function invalidate($lifetime = null){
@@ -11489,12 +10423,12 @@ namespace {
          * Migrates the current session to a new session id while maintaining all
          * session attributes.
          *
-         * @param bool $destroy Whether to delete the old session or leave it to garbage collection
+         * @param bool $destroy Whether to delete the old session or leave it to garbage collection.
          * @param int $lifetime Sets the cookie lifetime for the session cookie. A null value
          *                       will leave the system settings unchanged, 0 sets the cookie
          *                       to expire with browser session. Time is in seconds, and is
          *                       not a Unix timestamp.
-         * @return bool True if session migrated, false if error
+         * @return bool True if session migrated, false if error.
          * @static 
          */
         public static function migrate($destroy = false, $lifetime = null){
@@ -11536,17 +10470,6 @@ namespace {
         }
         
         /**
-         * Checks if an attribute exists.
-         *
-         * @param string|array $key
-         * @return bool 
-         * @static 
-         */
-        public static function exists($key){
-            return \Illuminate\Session\Store::exists($key);
-        }
-        
-        /**
          * Checks if an attribute is defined.
          *
          * @param string $name The attribute name
@@ -11561,7 +10484,7 @@ namespace {
          * Returns an attribute.
          *
          * @param string $name The attribute name
-         * @param mixed $default The default value if not found
+         * @param mixed $default The default value if not found.
          * @return mixed 
          * @static 
          */
@@ -11640,30 +10563,6 @@ namespace {
         }
         
         /**
-         * Increment the value of an item in the session.
-         *
-         * @param string $key
-         * @param int $amount
-         * @return mixed 
-         * @static 
-         */
-        public static function increment($key, $amount = 1){
-            return \Illuminate\Session\Store::increment($key, $amount);
-        }
-        
-        /**
-         * Decrement the value of an item in the session.
-         *
-         * @param string $key
-         * @param int $amount
-         * @return int 
-         * @static 
-         */
-        public static function decrement($key, $amount = 1){
-            return \Illuminate\Session\Store::decrement($key, $amount);
-        }
-        
-        /**
          * Flash a key / value pair to the session.
          *
          * @param string $key
